#include "brutforse.h"

BrutForse::BrutForse(int alevel):
    level(alevel)
{
}

void BrutForse::calculate(QVector<int>& matr)
{
    BaseCalc::calculate(matr);
    iters = fact(count);
}

void BrutForse::run()
{
    for (int i=0; i<count; ++i){
        QVector<int> vElse;
        for (int j=0; j<count; ++j)
            if (j!=i) vElse << j;
        recursive(QVector<int>()<<i, vElse);
    }
    drawPath(minPathPoints, QColor(200, 50, 50, 200));
}

void BrutForse::recursive(QVector<int> been, QVector<int> will)
{
    int n = will.count();
    if (n>0){
    for (int i=0; i<n; ++i){
        QVector<int> vElse;
        for (int j=0; j<n; ++j)
            if (j!=i) vElse << will[j];
        QVector<int> been2 = been;
        recursive(been2<<will[i], vElse);
    }}
    else {
        int m = been.count()-1;
        int sum = 0, pos;
        for (int i=0; i<m; ++i){
            pos = been[i]*count + been[i+1];
            sum += matrix[pos];
        }
        if (sum < minPath) {
            minPath = sum;
            minPathPoints = been;
        }
        current++;

        if (current % (iters/maxPst) == 0)
            emit progress(current*maxPst/iters);
    }
}
