#ifndef GRAF_H
#define GRAF_H

#include <QWidget>
#include <QTime>
#include <QTimer>
#include <QPainter>
#include <QVector>
#include <QMap>
#include <QPoint>
#include <QLine>
#include <QColor>

bool operator<(QPoint a, QPoint b);

class Graf : public QWidget
{
    Q_OBJECT
public:
    explicit Graf(QWidget *parent = 0);
    ~Graf();

    void townsInit(QVector<QPoint> tow) {
        towns = tow;
    }
    void clearLines() { lines.clear(); }

signals:
    
public slots:
    void drawLine(QPoint fromTo, QColor color);

protected:
    int count;
    QVector<QPoint> towns;
    QMap<QPoint, QColor> lines; // x=town1,y=town2,color=way
    void paintEvent(QPaintEvent *event);
    void clock();
};

#endif // GRAF_H
